Index: drivers/filesystems/btrfs/worker-thread.c
===================================================================
--- drivers/filesystems/btrfs/worker-thread.c	(révision 75772)
+++ drivers/filesystems/btrfs/worker-thread.c	(copie de travail)
@@ -1,17 +1,17 @@
-/* Copyright (c) Mark Harmstone 2016
- * 
+/* Copyright (c) Mark Harmstone 2016-17
+ *
  * This file is part of WinBtrfs.
- * 
+ *
  * WinBtrfs is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Lesser General Public Licence as published by
  * the Free Software Foundation, either version 3 of the Licence, or
  * (at your option) any later version.
- * 
+ *
  * WinBtrfs is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public Licence for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public Licence
  * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
 
@@ -31,60 +31,64 @@
     PFILE_OBJECT FileObject = IrpSp->FileObject;
     fcb* fcb = FileObject->FsContext;
     BOOL fcb_lock = FALSE;
-    
+
     Irp->IoStatus.Information = 0;
-    
+
     if (!ExIsResourceAcquiredSharedLite(fcb->Header.Resource)) {
         ExAcquireResourceSharedLite(fcb->Header.Resource, TRUE);
         fcb_lock = TRUE;
     }
-    
-    Status = do_read(Irp, TRUE, &bytes_read);
-    
+
+    _SEH2_TRY {
+        Status = do_read(Irp, TRUE, &bytes_read);
+    } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
+        Status = _SEH2_GetExceptionCode();
+    } _SEH2_END;
+
     if (fcb_lock)
         ExReleaseResourceLite(fcb->Header.Resource);
 
+    if (!NT_SUCCESS(Status))
+        ERR("do_read returned %08x\n", Status);
+
     Irp->IoStatus.Status = Status;
-    
-//     // fastfat doesn't do this, but the Wine ntdll file test seems to think we ought to
-//     if (Irp->UserIosb)
-//         *Irp->UserIosb = Irp->IoStatus;
-    
-    TRACE("Irp->IoStatus.Status = %08x\n", Irp->IoStatus.Status);
-    TRACE("Irp->IoStatus.Information = %lu\n", Irp->IoStatus.Information);
-    TRACE("returning %08x\n", Status);
-    
+
+    TRACE("read %lu bytes\n", Irp->IoStatus.Information);
+
     IoCompleteRequest(Irp, IO_NO_INCREMENT);
-    
-    if (top_level) 
+
+    if (top_level)
         IoSetTopLevelIrp(NULL);
+
+    TRACE("returning %08x\n", Status);
 }
 
 void do_write_job(device_extension* Vcb, PIRP Irp) {
     BOOL top_level = is_top_level(Irp);
     NTSTATUS Status;
-    
+
     _SEH2_TRY {
         Status = write_file(Vcb, Irp, TRUE, TRUE);
     } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
         Status = _SEH2_GetExceptionCode();
     } _SEH2_END;
-    
+
     if (!NT_SUCCESS(Status))
         ERR("write_file returned %08x\n", Status);
-    
+
     Irp->IoStatus.Status = Status;
 
     TRACE("wrote %u bytes\n", Irp->IoStatus.Information);
-    
+
     IoCompleteRequest(Irp, IO_NO_INCREMENT);
-    
-    if (top_level) 
+
+    if (top_level)
         IoSetTopLevelIrp(NULL);
-    
+
     TRACE("returning %08x\n", Status);
 }
 
+_Function_class_(WORKER_THREAD_ROUTINE)
 #ifdef __REACTOS__
 static void NTAPI do_job(void* context) {
 #else
@@ -92,34 +96,34 @@
 #endif
     job_info* ji = context;
     PIO_STACK_LOCATION IrpSp = ji->Irp ? IoGetCurrentIrpStackLocation(ji->Irp) : NULL;
-    
+
     if (IrpSp->MajorFunction == IRP_MJ_READ) {
         do_read_job(ji->Irp);
     } else if (IrpSp->MajorFunction == IRP_MJ_WRITE) {
         do_write_job(ji->Vcb, ji->Irp);
     }
-    
+
     ExFreePool(ji);
 }
 
 BOOL add_thread_job(device_extension* Vcb, PIRP Irp) {
     job_info* ji;
-    
+
     ji = ExAllocatePoolWithTag(NonPagedPool, sizeof(job_info), ALLOC_TAG);
     if (!ji) {
         ERR("out of memory\n");
         return FALSE;
     }
-    
+
     ji->Vcb = Vcb;
     ji->Irp = Irp;
-    
+
     if (!Irp->MdlAddress) {
         PMDL Mdl;
         LOCK_OPERATION op;
         ULONG len;
         PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
-        
+
         if (IrpSp->MajorFunction == IRP_MJ_READ) {
             op = IoWriteAccess;
             len = IrpSp->Parameters.Read.Length;
@@ -128,16 +132,18 @@
             len = IrpSp->Parameters.Write.Length;
         } else {
             ERR("unexpected major function %u\n", IrpSp->MajorFunction);
+            ExFreePool(ji);
             return FALSE;
         }
-        
+
         Mdl = IoAllocateMdl(Irp->UserBuffer, len, FALSE, FALSE, Irp);
 
         if (!Mdl) {
             ERR("out of memory\n");
+            ExFreePool(ji);
             return FALSE;
         }
-        
+
         _SEH2_TRY {
             MmProbeAndLockPages(Mdl, Irp->RequestorMode, op);
         } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
@@ -145,13 +151,14 @@
 
             IoFreeMdl(Mdl);
             Irp->MdlAddress = NULL;
+            ExFreePool(ji);
 
             _SEH2_YIELD(return FALSE);
         } _SEH2_END;
     }
-    
+
     ExInitializeWorkItem(&ji->item, do_job, ji);
     ExQueueWorkItem(&ji->item, DelayedWorkQueue);
-    
+
     return TRUE;
 }
Index: drivers/filesystems/btrfs/write.c
===================================================================
--- drivers/filesystems/btrfs/write.c	(révision 75772)
+++ drivers/filesystems/btrfs/write.c	(copie de travail)
@@ -1,66 +1,69 @@
-/* Copyright (c) Mark Harmstone 2016
- * 
+/* Copyright (c) Mark Harmstone 2016-17
+ *
  * This file is part of WinBtrfs.
- * 
+ *
  * WinBtrfs is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Lesser General Public Licence as published by
  * the Free Software Foundation, either version 3 of the Licence, or
  * (at your option) any later version.
- * 
+ *
  * WinBtrfs is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public Licence for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public Licence
  * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
 
 #include "btrfs_drv.h"
 
-// BOOL did_split;
-BOOL chunk_test = FALSE;
-
 typedef struct {
     UINT64 start;
     UINT64 end;
     UINT8* data;
-    UINT32 skip_start;
-    UINT32 skip_end;
+    PMDL mdl;
+    UINT64 irp_offset;
 } write_stripe;
 
-typedef struct {
-    LONG stripes_left;
-    KEVENT event;
-} read_stripe_master;
+_Function_class_(IO_COMPLETION_ROUTINE)
+#ifdef __REACTOS__
+static NTSTATUS NTAPI write_data_completion(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID conptr);
+#else
+static NTSTATUS write_data_completion(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID conptr);
+#endif
 
-typedef struct {
-    PIRP Irp;
-    PDEVICE_OBJECT devobj;
-    IO_STATUS_BLOCK iosb;
-    read_stripe_master* master;
-} read_stripe;
-
-// static BOOL extent_item_is_shared(EXTENT_ITEM* ei, ULONG len);
-static NTSTATUS STDCALL write_data_completion(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID conptr);
 static void remove_fcb_extent(fcb* fcb, extent* ext, LIST_ENTRY* rollback);
 
-extern tPsUpdateDiskCounters PsUpdateDiskCounters;
-extern tCcCopyWriteEx CcCopyWriteEx;
+extern tPsUpdateDiskCounters fPsUpdateDiskCounters;
+extern tCcCopyWriteEx fCcCopyWriteEx;
+extern tFsRtlUpdateDiskCounters fFsRtlUpdateDiskCounters;
 extern BOOL diskacc;
 
 BOOL find_data_address_in_chunk(device_extension* Vcb, chunk* c, UINT64 length, UINT64* address) {
     LIST_ENTRY* le;
     space* s;
-    
+
     TRACE("(%p, %llx, %llx, %p)\n", Vcb, c->offset, length, address);
-    
+
+    if (length > c->chunk_item->size - c->used)
+        return FALSE;
+
+    if (!c->cache_loaded) {
+        NTSTATUS Status = load_cache_chunk(Vcb, c, NULL);
+
+        if (!NT_SUCCESS(Status)) {
+            ERR("load_cache_chunk returned %08x\n", Status);
+            return FALSE;
+        }
+    }
+
     if (IsListEmpty(&c->space_size))
         return FALSE;
-    
+
     le = c->space_size.Flink;
     while (le != &c->space_size) {
         s = CONTAINING_RECORD(le, space, list_entry_size);
-        
+
         if (s->size == length) {
             *address = s->address;
             return TRUE;
@@ -67,48 +70,45 @@
         } else if (s->size < length) {
             if (le == c->space_size.Flink)
                 return FALSE;
-            
+
             s = CONTAINING_RECORD(le->Blink, space, list_entry_size);
-            
+
             *address = s->address;
             return TRUE;
         }
-        
+
         le = le->Flink;
     }
-    
+
     s = CONTAINING_RECORD(c->space_size.Blink, space, list_entry_size);
-    
+
     if (s->size > length) {
         *address = s->address;
         return TRUE;
     }
-    
+
     return FALSE;
 }
 
 chunk* get_chunk_from_address(device_extension* Vcb, UINT64 address) {
     LIST_ENTRY* le2;
-    chunk* c;
-    
+
     ExAcquireResourceSharedLite(&Vcb->chunk_lock, TRUE);
-    
+
     le2 = Vcb->chunks.Flink;
     while (le2 != &Vcb->chunks) {
-        c = CONTAINING_RECORD(le2, chunk, list_entry);
-        
-//         TRACE("chunk: %llx, %llx\n", c->offset, c->chunk_item->size);
-        
+        chunk* c = CONTAINING_RECORD(le2, chunk, list_entry);
+
         if (address >= c->offset && address < c->offset + c->chunk_item->size) {
             ExReleaseResourceLite(&Vcb->chunk_lock);
             return c;
         }
-         
+
         le2 = le2->Flink;
     }
-    
+
     ExReleaseResourceLite(&Vcb->chunk_lock);
-    
+
     return NULL;
 }
 
@@ -120,48 +120,48 @@
 static UINT64 find_new_chunk_address(device_extension* Vcb, UINT64 size) {
     UINT64 lastaddr;
     LIST_ENTRY* le;
-    
+
     lastaddr = 0xc00000;
-    
+
     le = Vcb->chunks.Flink;
     while (le != &Vcb->chunks) {
         chunk* c = CONTAINING_RECORD(le, chunk, list_entry);
-        
+
         if (c->offset >= lastaddr + size)
             return lastaddr;
-        
+
         lastaddr = c->offset + c->chunk_item->size;
-        
+
         le = le->Flink;
     }
-    
+
     return lastaddr;
 }
 
-static BOOL find_new_dup_stripes(device_extension* Vcb, stripe* stripes, UINT64 max_stripe_size) {
+static BOOL find_new_dup_stripes(device_extension* Vcb, stripe* stripes, UINT64 max_stripe_size, BOOL full_size) {
     UINT64 devusage = 0xffffffffffffffff;
     space *devdh1 = NULL, *devdh2 = NULL;
     LIST_ENTRY* le;
-    device* dev2;
-    
+    device* dev2 = NULL;
+
     le = Vcb->devices.Flink;
-    
+
     while (le != &Vcb->devices) {
         device* dev = CONTAINING_RECORD(le, device, list_entry);
-        
-        if (!dev->readonly && !dev->reloc) {
+
+        if (!dev->readonly && !dev->reloc && dev->devobj) {
             UINT64 usage = (dev->devitem.bytes_used * 4096) / dev->devitem.num_bytes;
-            
+
             // favour devices which have been used the least
             if (usage < devusage) {
                 if (!IsListEmpty(&dev->space)) {
                     LIST_ENTRY* le2;
                     space *dh1 = NULL, *dh2 = NULL;
-                    
+
                     le2 = dev->space.Flink;
                     while (le2 != &dev->space) {
                         space* dh = CONTAINING_RECORD(le2, space, list_entry);
-                        
+
                         if (dh->size >= max_stripe_size && (!dh1 || !dh2 || dh->size < dh1->size)) {
                             dh2 = dh1;
                             dh1 = dh;
@@ -169,7 +169,7 @@
 
                         le2 = le2->Flink;
                     }
-                    
+
                     if (dh1 && (dh2 || dh1->size >= 2 * max_stripe_size)) {
                         dev2 = dev;
                         devusage = usage;
@@ -179,28 +179,31 @@
                 }
             }
         }
-        
+
         le = le->Flink;
     }
-    
+
     if (!devdh1) {
         UINT64 size = 0;
-        
+
         // Can't find hole of at least max_stripe_size; look for the largest one we can find
-        
+
+        if (full_size)
+            return FALSE;
+
         le = Vcb->devices.Flink;
         while (le != &Vcb->devices) {
             device* dev = CONTAINING_RECORD(le, device, list_entry);
-            
+
             if (!dev->readonly && !dev->reloc) {
                 if (!IsListEmpty(&dev->space)) {
                     LIST_ENTRY* le2;
                     space *dh1 = NULL, *dh2 = NULL;
-                    
+
                     le2 = dev->space.Flink;
                     while (le2 != &dev->space) {
                         space* dh = CONTAINING_RECORD(le2, space, list_entry);
-                        
+
                         if (!dh1 || !dh2 || dh->size < dh1->size) {
                             dh2 = dh1;
                             dh1 = dh;
@@ -208,57 +211,57 @@
 
                         le2 = le2->Flink;
                     }
-                    
+
                     if (dh1) {
                         UINT64 devsize;
-                        
+
                         if (dh2)
                             devsize = max(dh1->size / 2, min(dh1->size, dh2->size));
                         else
-                            devsize = min(dh1->size, dh2->size);
-                        
+                            devsize = dh1->size / 2;
+
                         if (devsize > size) {
                             dev2 = dev;
                             devdh1 = dh1;
-                            
+
                             if (dh2 && min(dh1->size, dh2->size) > dh1->size / 2)
                                 devdh2 = dh2;
                             else
                                 devdh2 = dh1;
-                            
+
                             size = devsize;
                         }
                     }
                 }
             }
-            
+
             le = le->Flink;
         }
-        
+
         if (!devdh1)
             return FALSE;
     }
-    
+
     stripes[0].device = stripes[1].device = dev2;
     stripes[0].dh = devdh1;
     stripes[1].dh = devdh2;
-    
+
     return TRUE;
 }
 
-static BOOL find_new_stripe(device_extension* Vcb, stripe* stripes, UINT16 i, UINT64 max_stripe_size, UINT16 type) {
+static BOOL find_new_stripe(device_extension* Vcb, stripe* stripes, UINT16 i, UINT64 max_stripe_size, BOOL allow_missing, BOOL full_size) {
     UINT64 k, devusage = 0xffffffffffffffff;
     space* devdh = NULL;
     LIST_ENTRY* le;
     device* dev2 = NULL;
-    
+
     le = Vcb->devices.Flink;
     while (le != &Vcb->devices) {
         device* dev = CONTAINING_RECORD(le, device, list_entry);
         UINT64 usage;
         BOOL skip = FALSE;
-        
-        if (dev->readonly || dev->reloc) {
+
+        if (dev->readonly || dev->reloc || (!dev->devobj && !allow_missing)) {
             le = le->Flink;
             continue;
         }
@@ -272,19 +275,19 @@
                 }
             }
         }
-        
+
         if (!skip) {
             usage = (dev->devitem.bytes_used * 4096) / dev->devitem.num_bytes;
-            
+
             // favour devices which have been used the least
             if (usage < devusage) {
                 if (!IsListEmpty(&dev->space)) {
                     LIST_ENTRY* le2;
-                    
+
                     le2 = dev->space.Flink;
                     while (le2 != &dev->space) {
                         space* dh = CONTAINING_RECORD(le2, space, list_entry);
-                        
+
                         if ((dev2 != dev && dh->size >= max_stripe_size) ||
                             (dev2 == dev && dh->size >= max_stripe_size && dh->size < devdh->size)
                         ) {
@@ -298,19 +301,22 @@
                 }
             }
         }
-        
+
         le = le->Flink;
     }
-    
+
     if (!devdh) {
         // Can't find hole of at least max_stripe_size; look for the largest one we can find
-        
+
+        if (full_size)
+            return FALSE;
+
         le = Vcb->devices.Flink;
         while (le != &Vcb->devices) {
             device* dev = CONTAINING_RECORD(le, device, list_entry);
             BOOL skip = FALSE;
-            
-            if (dev->readonly || dev->reloc) {
+
+            if (dev->readonly || dev->reloc || (!dev->devobj && !allow_missing)) {
                 le = le->Flink;
                 continue;
             }
@@ -324,15 +330,15 @@
                     }
                 }
             }
-            
+
             if (!skip) {
                 if (!IsListEmpty(&dev->space)) {
                     LIST_ENTRY* le2;
-                    
+
                     le2 = dev->space.Flink;
                     while (le2 != &dev->space) {
                         space* dh = CONTAINING_RECORD(le2, space, list_entry);
-                        
+
                         if (!devdh || devdh->size < dh->size) {
                             devdh = dh;
                             dev2 = dev;
@@ -342,14 +348,14 @@
                     }
                 }
             }
-            
+
             le = le->Flink;
         }
-        
+
         if (!devdh)
             return FALSE;
     }
-    
+
     stripes[i].dh = devdh;
     stripes[i].device = dev2;
 
@@ -356,30 +362,28 @@
     return TRUE;
 }
 
-chunk* alloc_chunk(device_extension* Vcb, UINT64 flags) {
+NTSTATUS alloc_chunk(device_extension* Vcb, UINT64 flags, chunk** pc, BOOL full_size) {
+    NTSTATUS Status;
     UINT64 max_stripe_size, max_chunk_size, stripe_size, stripe_length, factor;
-    UINT64 total_size = 0, i, logaddr;
-    UINT16 type, num_stripes, sub_stripes, max_stripes, min_stripes;
+    UINT64 total_size = 0, logaddr;
+    UINT16 i, type, num_stripes, sub_stripes, max_stripes, min_stripes, allowed_missing;
     stripe* stripes = NULL;
-    ULONG cisize;
+    UINT16 cisize;
     CHUNK_ITEM_STRIPE* cis;
     chunk* c = NULL;
     space* s = NULL;
-    BOOL success = FALSE;
     LIST_ENTRY* le;
-    
-    ExAcquireResourceExclusiveLite(&Vcb->chunk_lock, TRUE);
-    
+
     le = Vcb->devices.Flink;
     while (le != &Vcb->devices) {
         device* dev = CONTAINING_RECORD(le, device, list_entry);
         total_size += dev->devitem.num_bytes;
-        
+
         le = le->Flink;
     }
-    
+
     TRACE("total_size = %llx\n", total_size);
-    
+
     // We purposely check for DATA first - mixed blocks have the same size
     // as DATA ones.
     if (flags & BLOCK_FLAG_DATA) {
@@ -390,101 +394,133 @@
             max_stripe_size = 0x40000000; // 1 GB
         else
             max_stripe_size = 0x10000000; // 256 MB
-        
+
         max_chunk_size = max_stripe_size;
     } else if (flags & BLOCK_FLAG_SYSTEM) {
         max_stripe_size = 0x2000000; // 32 MB
         max_chunk_size = 2 * max_stripe_size;
+    } else {
+        ERR("unknown chunk type\n");
+        return STATUS_INTERNAL_ERROR;
     }
-    
+
     max_chunk_size = min(max_chunk_size, total_size / 10); // cap at 10%
-    
+
     TRACE("would allocate a new chunk of %llx bytes and stripe %llx\n", max_chunk_size, max_stripe_size);
-    
+
     if (flags & BLOCK_FLAG_DUPLICATE) {
         min_stripes = 2;
         max_stripes = 2;
         sub_stripes = 0;
         type = BLOCK_FLAG_DUPLICATE;
+        allowed_missing = 0;
     } else if (flags & BLOCK_FLAG_RAID0) {
         min_stripes = 2;
-        max_stripes = Vcb->superblock.num_devices;
+        max_stripes = (UINT16)min(0xffff, Vcb->superblock.num_devices);
         sub_stripes = 0;
         type = BLOCK_FLAG_RAID0;
+        allowed_missing = 0;
     } else if (flags & BLOCK_FLAG_RAID1) {
         min_stripes = 2;
         max_stripes = 2;
         sub_stripes = 1;
         type = BLOCK_FLAG_RAID1;
+        allowed_missing = 1;
     } else if (flags & BLOCK_FLAG_RAID10) {
         min_stripes = 4;
-        max_stripes = Vcb->superblock.num_devices;
+        max_stripes = (UINT16)min(0xffff, Vcb->superblock.num_devices);
         sub_stripes = 2;
         type = BLOCK_FLAG_RAID10;
+        allowed_missing = 1;
     } else if (flags & BLOCK_FLAG_RAID5) {
         min_stripes = 3;
-        max_stripes = Vcb->superblock.num_devices;
+        max_stripes = (UINT16)min(0xffff, Vcb->superblock.num_devices);
         sub_stripes = 1;
         type = BLOCK_FLAG_RAID5;
+        allowed_missing = 1;
     } else if (flags & BLOCK_FLAG_RAID6) {
         min_stripes = 4;
         max_stripes = 257;
         sub_stripes = 1;
         type = BLOCK_FLAG_RAID6;
+        allowed_missing = 2;
     } else { // SINGLE
         min_stripes = 1;
         max_stripes = 1;
         sub_stripes = 1;
         type = 0;
+        allowed_missing = 0;
     }
-    
+
     stripes = ExAllocatePoolWithTag(PagedPool, sizeof(stripe) * max_stripes, ALLOC_TAG);
     if (!stripes) {
         ERR("out of memory\n");
+        Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
+
     num_stripes = 0;
-    
+
     if (type == BLOCK_FLAG_DUPLICATE) {
-        if (!find_new_dup_stripes(Vcb, stripes, max_stripe_size))
+        if (!find_new_dup_stripes(Vcb, stripes, max_stripe_size, full_size)) {
+            Status = STATUS_DISK_FULL;
             goto end;
+        }
         else
             num_stripes = max_stripes;
     } else {
         for (i = 0; i < max_stripes; i++) {
-            if (!find_new_stripe(Vcb, stripes, i, max_stripe_size, type))
+            if (!find_new_stripe(Vcb, stripes, i, max_stripe_size, FALSE, full_size))
                 break;
             else
                 num_stripes++;
         }
     }
-    
+
+    if (num_stripes < min_stripes && Vcb->options.allow_degraded && allowed_missing > 0) {
+        UINT16 added_missing = 0;
+
+        for (i = num_stripes; i < max_stripes; i++) {
+            if (!find_new_stripe(Vcb, stripes, i, max_stripe_size, TRUE, full_size))
+                break;
+            else {
+                added_missing++;
+                if (added_missing >= allowed_missing)
+                    break;
+            }
+        }
+
+        num_stripes += added_missing;
+    }
+
     // for RAID10, round down to an even number of stripes
     if (type == BLOCK_FLAG_RAID10 && (num_stripes % sub_stripes) != 0) {
         num_stripes -= num_stripes % sub_stripes;
     }
-    
+
     if (num_stripes < min_stripes) {
         WARN("found %u stripes, needed at least %u\n", num_stripes, min_stripes);
+        Status = STATUS_DISK_FULL;
         goto end;
     }
-    
+
     c = ExAllocatePoolWithTag(NonPagedPool, sizeof(chunk), ALLOC_TAG);
     if (!c) {
         ERR("out of memory\n");
+        Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
+
     cisize = sizeof(CHUNK_ITEM) + (num_stripes * sizeof(CHUNK_ITEM_STRIPE));
     c->chunk_item = ExAllocatePoolWithTag(NonPagedPool, cisize, ALLOC_TAG);
     if (!c->chunk_item) {
         ERR("out of memory\n");
+        Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
+
     stripe_length = 0x10000; // FIXME? BTRFS_STRIPE_LEN in kernel
-    
+
     if (type == BLOCK_FLAG_DUPLICATE && stripes[1].dh == stripes[0].dh)
         stripe_size = min(stripes[0].dh->size / 2, max_stripe_size);
     else {
@@ -494,7 +530,7 @@
                 stripe_size = stripes[i].dh->size;
         }
     }
-    
+
     if (type == 0 || type == BLOCK_FLAG_DUPLICATE || type == BLOCK_FLAG_RAID1)
         factor = 1;
     else if (type == BLOCK_FLAG_RAID0)
@@ -505,29 +541,32 @@
         factor = num_stripes - 1;
     else if (type == BLOCK_FLAG_RAID6)
         factor = num_stripes - 2;
-    
+
     if (stripe_size * factor > max_chunk_size)
         stripe_size = max_chunk_size / factor;
-    
+
     if (stripe_size % stripe_length > 0)
         stripe_size -= stripe_size % stripe_length;
-    
-    if (stripe_size == 0)
+
+    if (stripe_size == 0) {
+        Status = STATUS_INTERNAL_ERROR;
         goto end;
-    
+    }
+
     c->chunk_item->size = stripe_size * factor;
     c->chunk_item->root_id = Vcb->extent_root->id;
     c->chunk_item->stripe_length = stripe_length;
     c->chunk_item->type = flags;
-    c->chunk_item->opt_io_alignment = c->chunk_item->stripe_length;
-    c->chunk_item->opt_io_width = c->chunk_item->stripe_length;
+    c->chunk_item->opt_io_alignment = (UINT32)c->chunk_item->stripe_length;
+    c->chunk_item->opt_io_width = (UINT32)c->chunk_item->stripe_length;
     c->chunk_item->sector_size = stripes[0].device->devitem.minimal_io_size;
     c->chunk_item->num_stripes = num_stripes;
     c->chunk_item->sub_stripes = sub_stripes;
-    
+
     c->devices = ExAllocatePoolWithTag(NonPagedPool, sizeof(device*) * num_stripes, ALLOC_TAG);
     if (!c->devices) {
         ERR("out of memory\n");
+        Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
 
@@ -534,109 +573,130 @@
     cis = (CHUNK_ITEM_STRIPE*)&c->chunk_item[1];
     for (i = 0; i < num_stripes; i++) {
         cis[i].dev_id = stripes[i].device->devitem.dev_id;
-        
+
         if (type == BLOCK_FLAG_DUPLICATE && i == 1 && stripes[i].dh == stripes[0].dh)
             cis[i].offset = stripes[0].dh->address + stripe_size;
         else
             cis[i].offset = stripes[i].dh->address;
-        
+
         cis[i].dev_uuid = stripes[i].device->devitem.device_uuid;
-        
+
         c->devices[i] = stripes[i].device;
     }
-    
+
     logaddr = find_new_chunk_address(Vcb, c->chunk_item->size);
-    
+
     Vcb->superblock.chunk_root_generation = Vcb->superblock.generation;
-    
+
     c->size = cisize;
     c->offset = logaddr;
     c->used = c->oldused = 0;
-    c->cache = NULL;
+    c->cache = c->old_cache = NULL;
     c->readonly = FALSE;
     c->reloc = FALSE;
     c->last_alloc_set = FALSE;
-    
+    c->last_stripe = 0;
+    c->cache_loaded = TRUE;
+    c->changed = FALSE;
+    c->space_changed = FALSE;
+    c->balance_num = 0;
+
     InitializeListHead(&c->space);
     InitializeListHead(&c->space_size);
     InitializeListHead(&c->deleting);
     InitializeListHead(&c->changed_extents);
-    
+
     InitializeListHead(&c->range_locks);
-    KeInitializeSpinLock(&c->range_locks_spinlock);
+    ExInitializeResourceLite(&c->range_locks_lock);
     KeInitializeEvent(&c->range_locks_event, NotificationEvent, FALSE);
-    
+
+    InitializeListHead(&c->partial_stripes);
+    ExInitializeResourceLite(&c->partial_stripes_lock);
+
     ExInitializeResourceLite(&c->lock);
     ExInitializeResourceLite(&c->changed_extents_lock);
-    
+
     s = ExAllocatePoolWithTag(NonPagedPool, sizeof(space), ALLOC_TAG);
     if (!s) {
         ERR("out of memory\n");
+        Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
+
     s->address = c->offset;
     s->size = c->chunk_item->size;
     InsertTailList(&c->space, &s->list_entry);
     InsertTailList(&c->space_size, &s->list_entry_size);
-    
-    protect_superblocks(Vcb, c);
-    
+
+    protect_superblocks(c);
+
     for (i = 0; i < num_stripes; i++) {
         stripes[i].device->devitem.bytes_used += stripe_size;
-        
-        space_list_subtract2(Vcb, &stripes[i].device->space, NULL, cis[i].offset, stripe_size, NULL);
+
+        space_list_subtract2(&stripes[i].device->space, NULL, cis[i].offset, stripe_size, NULL, NULL);
     }
-    
-    success = TRUE;
-    
+
+    Status = STATUS_SUCCESS;
+
     if (flags & BLOCK_FLAG_RAID5 || flags & BLOCK_FLAG_RAID6)
         Vcb->superblock.incompat_flags |= BTRFS_INCOMPAT_FLAGS_RAID56;
-    
+
 end:
     if (stripes)
         ExFreePool(stripes);
-    
-    if (!success) {
-        if (c && c->chunk_item) ExFreePool(c->chunk_item);
-        if (c) ExFreePool(c);
+
+    if (!NT_SUCCESS(Status)) {
+        if (c) {
+            if (c->devices)
+                ExFreePool(c->devices);
+
+            if (c->chunk_item)
+                ExFreePool(c->chunk_item);
+
+            ExFreePool(c);
+        }
+
         if (s) ExFreePool(s);
     } else {
-        LIST_ENTRY* le;
         BOOL done = FALSE;
-        
+
         le = Vcb->chunks.Flink;
         while (le != &Vcb->chunks) {
             chunk* c2 = CONTAINING_RECORD(le, chunk, list_entry);
-            
+
             if (c2->offset > c->offset) {
                 InsertHeadList(le->Blink, &c->list_entry);
                 done = TRUE;
                 break;
             }
-            
+
             le = le->Flink;
         }
-        
+
         if (!done)
             InsertTailList(&Vcb->chunks, &c->list_entry);
-        
+
         c->created = TRUE;
-        InsertTailList(&Vcb->chunks_changed, &c->list_entry_changed);
+        c->changed = TRUE;
+        c->space_changed = TRUE;
         c->list_entry_balance.Flink = NULL;
+
+        *pc = c;
     }
-    
-    ExReleaseResourceLite(&Vcb->chunk_lock);
 
-    return success ? c : NULL;
+    return Status;
 }
 
-static NTSTATUS prepare_raid0_write(chunk* c, UINT64 address, void* data, UINT32 length, write_stripe* stripes) {
+static NTSTATUS prepare_raid0_write(_Pre_satisfies_(_Curr_->chunk_item->num_stripes>0) _In_ chunk* c, _In_ UINT64 address, _In_reads_bytes_(length) void* data,
+                                    _In_ UINT32 length, _In_ write_stripe* stripes, _In_ PIRP Irp, _In_ UINT64 irp_offset, _In_ write_data_context* wtc) {
     UINT64 startoff, endoff;
     UINT16 startoffstripe, endoffstripe, stripenum;
     UINT64 pos, *stripeoff;
     UINT32 i;
-    
+    BOOL file_write = Irp && Irp->MdlAddress && (Irp->MdlAddress->ByteOffset == 0);
+    PMDL master_mdl;
+    PFN_NUMBER* pfns;
+
     stripeoff = ExAllocatePoolWithTag(PagedPool, sizeof(UINT64) * c->chunk_item->num_stripes, ALLOC_TAG);
     if (!stripeoff) {
         ERR("out of memory\n");
